/**
 * DevExtreme (ui/file_manager/ui.file_manager.editing.js)
 * Version: 19.1.0 (build 19085-0305)
 * Build date: Tue Mar 26 2019
 *
 * Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) {
                descriptor.writable = true
            }
            Object.defineProperty(target, descriptor.key, descriptor)
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) {
            defineProperties(Constructor.prototype, protoProps)
        }
        if (staticProps) {
            defineProperties(Constructor, staticProps)
        }
        return Constructor
    }
}();
var _get = function get(object, property, receiver) {
    if (null === object) {
        object = Function.prototype
    }
    var desc = Object.getOwnPropertyDescriptor(object, property);
    if (void 0 === desc) {
        var parent = Object.getPrototypeOf(object);
        if (null === parent) {
            return
        } else {
            return get(parent, property, receiver)
        }
    } else {
        if ("value" in desc) {
            return desc.value
        } else {
            var getter = desc.get;
            if (void 0 === getter) {
                return
            }
            return getter.call(receiver)
        }
    }
};
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _extend = require("../../core/utils/extend");
var _deferred = require("../../core/utils/deferred");
var _ui = require("../widget/ui.widget");
var _ui2 = _interopRequireDefault(_ui);
var _uiFile_manager = require("./ui.file_manager.common");
var _uiFile_manager2 = _interopRequireDefault(_uiFile_manager);
var _uiFile_managerDialog = require("./ui.file_manager.dialog.name_editor");
var _uiFile_managerDialog2 = _interopRequireDefault(_uiFile_managerDialog);
var _uiFile_managerDialog3 = require("./ui.file_manager.dialog.folder_chooser");
var _uiFile_managerDialog4 = _interopRequireDefault(_uiFile_managerDialog3);
var _uiFile_manager3 = require("./ui.file_manager.file_uploader");
var _uiFile_manager4 = _interopRequireDefault(_uiFile_manager3);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _possibleConstructorReturn(self, call) {
    if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return call && ("object" === typeof call || "function" === typeof call) ? call : self
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass)
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass
    }
}
var FileManagerEditingControl = function(_Widget) {
    _inherits(FileManagerEditingControl, _Widget);

    function FileManagerEditingControl() {
        _classCallCheck(this, FileManagerEditingControl);
        return _possibleConstructorReturn(this, (FileManagerEditingControl.__proto__ || Object.getPrototypeOf(FileManagerEditingControl)).apply(this, arguments))
    }
    _createClass(FileManagerEditingControl, [{
        key: "_init",
        value: function() {
            this._commands = {
                rename: this._tryRename,
                create: this._tryCreate,
                "delete": this._tryDelete,
                move: this._tryMove,
                copy: this._tryCopy,
                upload: this._tryUpload
            };
            _get(FileManagerEditingControl.prototype.__proto__ || Object.getPrototypeOf(FileManagerEditingControl.prototype), "_init", this).call(this)
        }
    }, {
        key: "_initMarkup",
        value: function() {
            _get(FileManagerEditingControl.prototype.__proto__ || Object.getPrototypeOf(FileManagerEditingControl.prototype), "_initMarkup", this).call(this);
            this._model = this.option("model");
            this._provider = this._model.provider;
            this._renameItemDialog = this._createEnterNameDialog("Rename", "Save");
            this._createFolderDialog = this._createEnterNameDialog("Folder", "Create");
            this._chooseFolderDialog = this._createComponent((0, _renderer2.default)("<div>"), _uiFile_managerDialog4.default, {
                provider: this._provider,
                getItems: this._model.getFolders,
                onClosed: this._onDialogClosed.bind(this)
            });
            this._confirmationDialog = this._createConfirmationDialog();
            this._fileUploader = this._createFileUploader();
            this.$element().append(this._renameItemDialog.$element()).append(this._createFolderDialog.$element()).append(this._chooseFolderDialog.$element()).append(this._fileUploader.$element())
        }
    }, {
        key: "_createFileUploader",
        value: function() {
            var _this2 = this;
            return this._createComponent((0, _renderer2.default)("<div>"), _uiFile_manager4.default, {
                onGetController: this._getFileUploaderController.bind(this),
                onFilesUploaded: function(result) {
                    return _this2._raiseOnSuccess("Files uploaded", true)
                },
                onErrorOccurred: function(e) {
                    var title = "Upload failed for the '" + e.fileName + "' file";
                    _this2._raiseOnError(title, e.error)
                }
            })
        }
    }, {
        key: "_getFileUploaderController",
        value: function() {
            var destinationFolder = this._model.getCurrentFolder();
            var that = this;
            return {
                chunkSize: this._provider.getFileUploadChunkSize(),
                initiateUpload: function(state) {
                    state.destinationFolder = destinationFolder;
                    return (0, _deferred.when)(that._provider.initiateFileUpload(state))
                },
                uploadChunk: function(state, chunk) {
                    return (0, _deferred.when)(that._provider.uploadFileChunk(state, chunk))
                },
                finalizeUpload: function(state) {
                    return (0, _deferred.when)(that._provider.finalizeFileUpload(state))
                },
                abortUpload: function(state) {
                    return (0, _deferred.when)(that._provider.abortFileUpload(state))
                }
            }
        }
    }, {
        key: "_createEnterNameDialog",
        value: function(title, buttonText) {
            return this._createComponent((0, _renderer2.default)("<div>"), _uiFile_managerDialog2.default, {
                title: title,
                buttonText: buttonText,
                onClosed: this._onDialogClosed.bind(this)
            })
        }
    }, {
        key: "_createConfirmationDialog",
        value: function() {
            var _this3 = this;
            return {
                show: function() {
                    setTimeout(function() {
                        _this3._onDialogClosed({})
                    })
                }
            }
        }
    }, {
        key: "_tryRename",
        value: function() {
            var _this4 = this;
            var item = this._model.getSingleSelectedItem();
            if (!item) {
                return
            }
            this._tryEditAction(this._renameItemDialog, function(result) {
                return _this4._provider.renameItem(item, result.name)
            }, "Item renamed", function(info) {
                return "Rename operation failed for the " + item.name + " item"
            }, item.name)
        }
    }, {
        key: "_tryCreate",
        value: function() {
            var _this5 = this;
            var item = this._model.getCurrentFolder();
            var onCreatingHandler = this.option("onCreating");
            onCreatingHandler();
            this._tryEditAction(this._createFolderDialog, function(result) {
                return _this5._provider.createFolder(item, result.name)
            }, "Folder created", function(info) {
                return "Create folder operation failed for the " + item.name + " parent folder"
            })
        }
    }, {
        key: "_tryDelete",
        value: function() {
            var _this6 = this;
            var items = this._model.getMultipleSelectedItems();
            if (0 === items.length) {
                return
            }
            this._tryEditAction(this._confirmationDialog, function(result) {
                return _this6._provider.deleteItems(items)
            }, "Items deleted", function(info) {
                return "Delete operation failed for the " + items[info.index].name + " item"
            })
        }
    }, {
        key: "_tryMove",
        value: function() {
            var _this7 = this;
            var items = this._model.getMultipleSelectedItems();
            if (0 === items.length) {
                return
            }
            this._tryEditAction(this._chooseFolderDialog, function(result) {
                return _this7._provider.moveItems(items, result.folder)
            }, "Items moved", function(info) {
                return "Move operation failed for the " + items[info.index].name + " item"
            })
        }
    }, {
        key: "_tryCopy",
        value: function() {
            var _this8 = this;
            var items = this._model.getMultipleSelectedItems();
            if (0 === items.length) {
                return
            }
            this._tryEditAction(this._chooseFolderDialog, function(result) {
                return _this8._provider.copyItems(items, result.folder)
            }, "Items copied", function(info) {
                return "Copy operation failed for the " + items[info.index].name + " item"
            })
        }
    }, {
        key: "_tryEditAction",
        value: function(dialog, editAction, successMessage, errorMessageAction, dialogArgument) {
            var _this9 = this;
            this._showDialog(dialog, dialogArgument).then(editAction.bind(this)).then(function(result) {
                (0, _uiFile_manager2.default)(result, function() {
                    return _this9._raiseOnSuccess(successMessage)
                }, function(info) {
                    return _this9._raiseOnError(errorMessageAction(info), info.error)
                })
            })
        }
    }, {
        key: "_tryUpload",
        value: function() {
            this._fileUploader.tryUpload()
        }
    }, {
        key: "_showDialog",
        value: function(dialog, dialogArgument) {
            this._dialogDeferred = new _deferred.Deferred;
            dialog.show(dialogArgument);
            return this._dialogDeferred.promise()
        }
    }, {
        key: "_onDialogClosed",
        value: function(result) {
            if (result) {
                this._dialogDeferred.resolve(result)
            } else {
                this._dialogDeferred.reject()
            }
        }
    }, {
        key: "_getDefaultOptions",
        value: function() {
            return (0, _extend.extend)(_get(FileManagerEditingControl.prototype.__proto__ || Object.getPrototypeOf(FileManagerEditingControl.prototype), "_getDefaultOptions", this).call(this), {
                model: {
                    provider: null,
                    getFolders: null,
                    getCurrentFolder: null,
                    getSingleSelectedItem: null,
                    getMultipleSelectedItems: null
                },
                onSuccess: null,
                onError: null,
                onCreating: null
            })
        }
    }, {
        key: "_raiseOnSuccess",
        value: function(message) {
            var handler = this.option("onSuccess");
            handler(message)
        }
    }, {
        key: "_raiseOnError",
        value: function(errorTitle, errorDetails) {
            var handler = this.option("onError");
            handler(errorTitle, errorDetails)
        }
    }, {
        key: "executeCommand",
        value: function(commandName) {
            var action = this._commands[commandName];
            if (action) {
                action.call(this);
                return true
            } else {
                return false
            }
        }
    }]);
    return FileManagerEditingControl
}(_ui2.default);
module.exports = FileManagerEditingControl;
