/**
 * DevExtreme (ui/file_manager/ui.file_manager.js)
 * Version: 19.1.0 (build 19085-0305)
 * Build date: Tue Mar 26 2019
 *
 * Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) {
                descriptor.writable = true
            }
            Object.defineProperty(target, descriptor.key, descriptor)
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) {
            defineProperties(Constructor.prototype, protoProps)
        }
        if (staticProps) {
            defineProperties(Constructor, staticProps)
        }
        return Constructor
    }
}();
var _get = function get(object, property, receiver) {
    if (null === object) {
        object = Function.prototype
    }
    var desc = Object.getOwnPropertyDescriptor(object, property);
    if (void 0 === desc) {
        var parent = Object.getPrototypeOf(object);
        if (null === parent) {
            return
        } else {
            return get(parent, property, receiver)
        }
    } else {
        if ("value" in desc) {
            return desc.value
        } else {
            var getter = desc.get;
            if (void 0 === getter) {
                return
            }
            return getter.call(receiver)
        }
    }
};
var _renderer = require("../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _events_engine = require("../../events/core/events_engine");
var _events_engine2 = _interopRequireDefault(_events_engine);
var _extend = require("../../core/utils/extend");
var _type = require("../../core/utils/type");
var _type2 = _interopRequireDefault(_type);
var _component_registrator = require("../../core/component_registrator");
var _component_registrator2 = _interopRequireDefault(_component_registrator);
var _ui = require("../widget/ui.widget");
var _ui2 = _interopRequireDefault(_ui);
var _notify = require("../notify");
var _notify2 = _interopRequireDefault(_notify);
var _uiFile_manager = require("./ui.file_manager.files_tree_view");
var _uiFile_manager2 = _interopRequireDefault(_uiFile_manager);
var _uiFile_managerItem_list = require("./ui.file_manager.item_list.details");
var _uiFile_managerItem_list2 = _interopRequireDefault(_uiFile_managerItem_list);
var _uiFile_managerItem_list3 = require("./ui.file_manager.item_list.thumbnails");
var _uiFile_managerItem_list4 = _interopRequireDefault(_uiFile_managerItem_list3);
var _uiFile_manager3 = require("./ui.file_manager.toolbar");
var _uiFile_manager4 = _interopRequireDefault(_uiFile_manager3);
var _uiFile_manager5 = require("./ui.file_manager.editing");
var _uiFile_manager6 = _interopRequireDefault(_uiFile_manager5);
var _uiFile_manager7 = require("./ui.file_manager.breadcrumbs");
var _uiFile_manager8 = _interopRequireDefault(_uiFile_manager7);
var _file_provider = require("../../file_provider/file_provider");
var _file_provider2 = require("../../file_provider/file_provider.array");
var _file_provider3 = _interopRequireDefault(_file_provider2);
var _file_provider4 = require("../../file_provider/file_provider.ajax");
var _file_provider5 = _interopRequireDefault(_file_provider4);
var _file_provider6 = require("../../file_provider/file_provider.onedrive");
var _file_provider7 = _interopRequireDefault(_file_provider6);
var _file_provider8 = require("../../file_provider/file_provider.webapi");
var _file_provider9 = _interopRequireDefault(_file_provider8);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _possibleConstructorReturn(self, call) {
    if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return call && ("object" === typeof call || "function" === typeof call) ? call : self
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass)
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass
    }
}
var FILE_MANAGER_CLASS = "dx-filemanager";
var FILE_MANAGER_CONTAINER_CLASS = FILE_MANAGER_CLASS + "-container";
var FILE_MANAGER_DIRS_TREE_CLASS = FILE_MANAGER_CLASS + "-dirs-tree";
var FILE_MANAGER_VIEW_SEPARATOR_CLASS = FILE_MANAGER_CLASS + "-view-separator";
var FILE_MANAGER_TOOLBAR_CLASS = FILE_MANAGER_CLASS + "-toolbar";
var FILE_MANAGER_INACTIVE_AREA_CLASS = FILE_MANAGER_CLASS + "-inactive-area";
var FILE_MANAGER_EDITING_CONTAINER_CLASS = FILE_MANAGER_CLASS + "-editing-container";
var FILE_MANAGER_ITEMS_PANEL_CLASS = FILE_MANAGER_CLASS + "-items-panel";
var FileManager = function(_Widget) {
    _inherits(FileManager, _Widget);

    function FileManager() {
        _classCallCheck(this, FileManager);
        return _possibleConstructorReturn(this, (FileManager.__proto__ || Object.getPrototypeOf(FileManager)).apply(this, arguments))
    }
    _createClass(FileManager, [{
        key: "_init",
        value: function() {
            var _this2 = this;
            this._commands = {
                open: function() {
                    return _this2._tryOpen()
                },
                thumbnails: function() {
                    return _this2._switchView("thumbnails")
                },
                details: function() {
                    return _this2._switchView("details")
                }
            };
            _get(FileManager.prototype.__proto__ || Object.getPrototypeOf(FileManager.prototype), "_init", this).call(this)
        }
    }, {
        key: "_initTemplates",
        value: function() {}
    }, {
        key: "_initMarkup",
        value: function() {
            _get(FileManager.prototype.__proto__ || Object.getPrototypeOf(FileManager.prototype), "_initMarkup", this).call(this);
            this._provider = this._getFileProvider();
            var toolbar = this._createComponent((0, _renderer2.default)("<div>"), _uiFile_manager4.default, {
                onItemClick: this._onToolbarItemClick.bind(this)
            });
            toolbar.$element().addClass(FILE_MANAGER_TOOLBAR_CLASS);
            this._createEditing();
            this._$viewContainer = this._createViewContainer();
            this.$element().append(toolbar.$element()).append(this._$viewContainer).append(this._editing.$element()).addClass(FILE_MANAGER_CLASS);
            this._setItemsViewAreaActive(false)
        }
    }, {
        key: "_createEditing",
        value: function() {
            var _this3 = this;
            this._editing = this._createComponent((0, _renderer2.default)("<div>"), _uiFile_manager6.default, {
                model: {
                    provider: this._provider,
                    getFolders: this._getFilesTreeViewItems.bind(this),
                    getCurrentFolder: this.getCurrentFolder.bind(this),
                    getSingleSelectedItem: this._getSingleSelectedItem.bind(this),
                    getMultipleSelectedItems: this._getMultipleSelectedItems.bind(this)
                },
                onSuccess: function(message, updateOnlyFiles) {
                    _this3._showSuccess(message);
                    _this3._refreshData(updateOnlyFiles)
                },
                onError: function(title, details) {
                    return _this3._showError(title + ": " + _this3._getErrorText(details))
                },
                onCreating: function() {
                    return _this3._setItemsViewAreaActive(false)
                }
            });
            this._editing.$element().addClass(FILE_MANAGER_EDITING_CONTAINER_CLASS)
        }
    }, {
        key: "_createViewContainer",
        value: function() {
            var $container = (0, _renderer2.default)("<div>");
            $container.addClass(FILE_MANAGER_CONTAINER_CLASS);
            this._createFilesTreeView();
            $container.append(this._filesTreeView.$element());
            var $viewSeparator = (0, _renderer2.default)("<div>");
            $viewSeparator.addClass(FILE_MANAGER_VIEW_SEPARATOR_CLASS);
            $container.append($viewSeparator);
            this._createBreadcrumbs();
            this._createItemList();
            this._$itemsPanel = (0, _renderer2.default)("<div>").addClass(FILE_MANAGER_ITEMS_PANEL_CLASS);
            this._$itemsPanel.append(this._breadcrumbs.$element(), this._itemList.$element());
            $container.append(this._$itemsPanel);
            return $container
        }
    }, {
        key: "_createFilesTreeView",
        value: function() {
            var _this4 = this;
            this._filesTreeView = this._createComponent((0, _renderer2.default)("<div>"), _uiFile_manager2.default, {
                getItems: this._getFilesTreeViewItems.bind(this),
                onCurrentFolderChanged: this._onFilesTreeViewCurrentFolderChanged.bind(this),
                onClick: function() {
                    return _this4._setItemsViewAreaActive(false)
                }
            });
            this._filesTreeView.$element().addClass(FILE_MANAGER_DIRS_TREE_CLASS)
        }
    }, {
        key: "_createItemList",
        value: function(viewMode) {
            var _this5 = this;
            var itemListOptions = this.option("itemList");
            var selectionOptions = this.option("selection");
            var options = {
                selectionMode: selectionOptions.mode,
                onGetItems: this._getItemListItems.bind(this),
                onError: this._showError.bind(this),
                onSelectedItemOpened: function(item) {
                    return _this5._tryOpen(item)
                },
                getItemThumbnail: this._getItemThumbnail.bind(this)
            };
            viewMode = viewMode || itemListOptions.mode;
            var widgetClass = "thumbnails" === viewMode ? _uiFile_managerItem_list4.default : _uiFile_managerItem_list2.default;
            this._itemList = this._createComponent((0, _renderer2.default)("<div>"), widgetClass, options);
            _events_engine2.default.on(this._itemList.$element(), "click", this._onItemListClick.bind(this))
        }
    }, {
        key: "_createBreadcrumbs",
        value: function() {
            var _this6 = this;
            this._breadcrumbs = this._createComponent((0, _renderer2.default)("<div>"), _uiFile_manager8.default, {
                path: "",
                onPathChanged: function(path) {
                    return _this6.setCurrentPath(path)
                }
            })
        }
    }, {
        key: "_onFilesTreeViewCurrentFolderChanged",
        value: function(e) {
            this._loadItemListData();
            this._breadcrumbs.option("path", this.getCurrentFolderPath())
        }
    }, {
        key: "_onToolbarItemClick",
        value: function(buttonName) {
            this.executeCommand(buttonName)
        }
    }, {
        key: "_setItemsViewAreaActive",
        value: function(active) {
            if (this._itemsViewAreaActive === active) {
                return
            }
            this._itemsViewAreaActive = active;
            var $activeArea = null;
            var $inactiveArea = null;
            if (active) {
                $activeArea = this._itemList.$element();
                $inactiveArea = this._filesTreeView.$element()
            } else {
                $activeArea = this._filesTreeView.$element();
                $inactiveArea = this._itemList.$element()
            }
            $activeArea.removeClass(FILE_MANAGER_INACTIVE_AREA_CLASS);
            $inactiveArea.addClass(FILE_MANAGER_INACTIVE_AREA_CLASS)
        }
    }, {
        key: "_tryOpen",
        value: function(item) {
            if (!item) {
                var items = this.getSelectedItems();
                if (items.length > 0) {
                    item = items[0]
                }
            }
            if (!item || !item.isFolder) {
                return
            }
            this.setCurrentPath(item.relativeName)
        }
    }, {
        key: "_switchView",
        value: function(viewMode) {
            this._itemList.dispose();
            this._itemList.$element().remove();
            this._createItemList(viewMode);
            this._$itemsPanel.append(this._itemList.$element())
        }
    }, {
        key: "_getSingleSelectedItem",
        value: function() {
            if (this._itemsViewAreaActive) {
                var items = this.getSelectedItems();
                if (1 === items.length) {
                    return items[0]
                }
            } else {
                return this.getCurrentFolder()
            }
            return null
        }
    }, {
        key: "_getMultipleSelectedItems",
        value: function() {
            return this._itemsViewAreaActive ? this.getSelectedItems() : [this.getCurrentFolder()]
        }
    }, {
        key: "_showSuccess",
        value: function(message) {
            this._showNotification(message, true)
        }
    }, {
        key: "_showError",
        value: function(error) {
            var message = this._getErrorText(error);
            this._showNotification(message, false)
        }
    }, {
        key: "_getErrorText",
        value: function(error) {
            var result = "string" === typeof error ? error : error.responseText;
            return result || "General error"
        }
    }, {
        key: "_showNotification",
        value: function(message, isSuccess) {
            (0, _notify2.default)({
                message: message,
                width: 450
            }, isSuccess ? "success" : "error", 5e3)
        }
    }, {
        key: "_loadItemListData",
        value: function() {
            this._itemList.refreshData()
        }
    }, {
        key: "_refreshData",
        value: function(onlyItems) {
            if (onlyItems || this._itemsViewAreaActive) {
                this._loadItemListData()
            } else {
                this._filesTreeView.refreshData()
            }
        }
    }, {
        key: "_getFilesTreeViewItems",
        value: function(parent) {
            var path = parent ? parent.relativeName : "";
            return this._provider.getFolders(path)
        }
    }, {
        key: "_getItemListItems",
        value: function() {
            var path = this.getCurrentFolderPath();
            var showFolders = this.option("itemList").showFolders;
            var itemType = showFolders ? "" : "file";
            return this._provider.getItems(path, itemType)
        }
    }, {
        key: "_onItemListClick",
        value: function() {
            this._setItemsViewAreaActive(true)
        }
    }, {
        key: "_getFileProvider",
        value: function() {
            var fileSystemStore = this.option("fileSystemStore");
            if (!fileSystemStore) {
                fileSystemStore = []
            }
            if (Array.isArray(fileSystemStore)) {
                return new _file_provider3.default(fileSystemStore)
            }
            if ("string" === typeof fileSystemStore) {
                return new _file_provider5.default({
                    url: fileSystemStore
                })
            }
            if (fileSystemStore instanceof _file_provider.FileProvider) {
                return fileSystemStore
            }
            if (fileSystemStore.type) {
                switch (fileSystemStore.type) {
                    case "webapi":
                        return new _file_provider9.default(fileSystemStore);
                    case "onedrive":
                        return new _file_provider7.default(fileSystemStore)
                }
            }
            return new _file_provider3.default([])
        }
    }, {
        key: "_getItemThumbnail",
        value: function(item) {
            var func = this.option("customThumbnail");
            var thumbnail = _type2.default.isFunction(func) ? func(item) : item.thumbnail;
            return thumbnail || this._getPredefinedThumbnail(item)
        }
    }, {
        key: "_getPredefinedThumbnail",
        value: function(item) {
            if (item.isFolder) {
                return "folder"
            }
            var extension = item.getExtension();
            switch (extension) {
                case ".txt":
                    return "doc";
                case ".rtf":
                case ".doc":
                case ".docx":
                case ".odt":
                    return "doc";
                case ".xls":
                case ".xlsx":
                case ".ods":
                    return "exportxlsx";
                case ".ppt":
                case ".pptx":
                case ".odp":
                    return "doc";
                case ".pdf":
                    return "exportpdf";
                case ".png":
                case ".gif":
                case ".jpg":
                case ".jpeg":
                case ".ico":
                case ".bmp":
                    return "image";
                default:
                    return "doc"
            }
        }
    }, {
        key: "_getDefaultOptions",
        value: function() {
            return (0, _extend.extend)(_get(FileManager.prototype.__proto__ || Object.getPrototypeOf(FileManager.prototype), "_getDefaultOptions", this).call(this), {
                fileSystemStore: null,
                selection: {
                    mode: "single"
                },
                itemList: {
                    mode: "details",
                    showFolders: true
                },
                customThumbnail: null
            })
        }
    }, {
        key: "_optionChanged",
        value: function(args) {
            var name = args.name;
            switch (name) {
                case "fileSystemStore":
                case "selection":
                case "itemList":
                    this.repaint();
                    break;
                case "customThumbnail":
                    break;
                default:
                    _get(FileManager.prototype.__proto__ || Object.getPrototypeOf(FileManager.prototype), "_optionChanged", this).call(this, args)
            }
        }
    }, {
        key: "executeCommand",
        value: function(commandName) {
            var done = this._editing.executeCommand(commandName);
            if (done) {
                return
            }
            var action = this._commands[commandName];
            if (!action) {
                throw "Incorrect command name."
            }
            action.call(this)
        }
    }, {
        key: "setCurrentPath",
        value: function(path) {
            this._filesTreeView.setCurrentPath(path)
        }
    }, {
        key: "getCurrentFolderPath",
        value: function() {
            return this._filesTreeView.getCurrentPath()
        }
    }, {
        key: "getCurrentFolder",
        value: function() {
            return this._filesTreeView.getCurrentFolder()
        }
    }, {
        key: "getSelectedItems",
        value: function() {
            return this._itemList.getSelectedItems()
        }
    }]);
    return FileManager
}(_ui2.default);
(0, _component_registrator2.default)("dxFileManager", FileManager);
module.exports = FileManager;
