/**
 * DevExtreme (ui/scheduler/compact_strategies/compactAppointmentsDesktopStrategy.js)
 * Version: 19.1.0 (build 19085-0305)
 * Build date: Tue Mar 26 2019
 *
 * Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CompactAppointmentsDesktopStrategy = void 0;
var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) {
                descriptor.writable = true
            }
            Object.defineProperty(target, descriptor.key, descriptor)
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) {
            defineProperties(Constructor.prototype, protoProps)
        }
        if (staticProps) {
            defineProperties(Constructor, staticProps)
        }
        return Constructor
    }
}();
var _renderer = require("../../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _compactAppointmentsStrategyBase = require("./compactAppointmentsStrategyBase");
var _translator = require("../../../animation/translator");
var _translator2 = _interopRequireDefault(_translator);
var _type = require("../../../core/utils/type");
var _type2 = _interopRequireDefault(_type);
var _drag = require("../../../events/drag");
var _drag2 = _interopRequireDefault(_drag);
var _utils = require("../../../events/utils");
var _utils2 = _interopRequireDefault(_utils);
var _events_engine = require("../../../events/core/events_engine");
var _events_engine2 = _interopRequireDefault(_events_engine);
var _button = require("../../button");
var _button2 = _interopRequireDefault(_button);
var _drop_down_menu = require("../../drop_down_menu");
var _drop_down_menu2 = _interopRequireDefault(_drop_down_menu);
var _function_template = require("../../widget/function_template");
var _function_template2 = _interopRequireDefault(_function_template);
var _message = require("../../../localization/message");
var _message2 = _interopRequireDefault(_message);
var _extend = require("../../../core/utils/extend");
var _deferred = require("../../../core/utils/deferred");
var _deferred2 = _interopRequireDefault(_deferred);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _possibleConstructorReturn(self, call) {
    if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return call && ("object" === typeof call || "function" === typeof call) ? call : self
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass)
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass
    }
}
var when = _deferred2.default.when;
var OFFSET = 5,
    REMOVE_BUTTON_SIZE = 25;
var DROPDOWN_APPOINTMENTS_CLASS = "dx-scheduler-dropdown-appointments",
    COMPACT_DROPDOWN_APPOINTMENTS_CLASS = DROPDOWN_APPOINTMENTS_CLASS + "-compact",
    DROPDOWN_APPOINTMENTS_CONTENT_CLASS = "dx-scheduler-dropdown-appointments-content",
    DROPDOWN_APPOINTMENT_CLASS = "dx-scheduler-dropdown-appointment",
    DROPDOWN_APPOINTMENT_TITLE_CLASS = "dx-scheduler-dropdown-appointment-title",
    DROPDOWN_APPOINTMENT_DATE_CLASS = "dx-scheduler-dropdown-appointment-date",
    DROPDOWN_APPOINTMENT_REMOVE_BUTTON_CLASS = "dx-scheduler-dropdown-appointment-remove-button",
    DROPDOWN_APPOINTMENT_INFO_BLOCK_CLASS = "dx-scheduler-dropdown-appointment-info-block",
    DROPDOWN_APPOINTMENT_BUTTONS_BLOCK_CLASS = "dx-scheduler-dropdown-appointment-buttons-block";
var DRAG_START_EVENT_NAME = _utils2.default.addNamespace(_drag2.default.start, "dropDownAppointments"),
    DRAG_UPDATE_EVENT_NAME = _utils2.default.addNamespace(_drag2.default.move, "dropDownAppointments"),
    DRAG_END_EVENT_NAME = _utils2.default.addNamespace(_drag2.default.end, "dropDownAppointments");
var SIDE_BORDER_COLOR_STYLES = {
    left: "borderLeftColor",
    top: "borderTopColor",
    right: "borderRightColor",
    bottom: "borderBottomColor"
};
var CompactAppointmentsDesktopStrategy = exports.CompactAppointmentsDesktopStrategy = function(_CompactAppointmentsS) {
    _inherits(CompactAppointmentsDesktopStrategy, _CompactAppointmentsS);

    function CompactAppointmentsDesktopStrategy() {
        _classCallCheck(this, CompactAppointmentsDesktopStrategy);
        return _possibleConstructorReturn(this, (CompactAppointmentsDesktopStrategy.__proto__ || Object.getPrototypeOf(CompactAppointmentsDesktopStrategy)).apply(this, arguments))
    }
    _createClass(CompactAppointmentsDesktopStrategy, [{
        key: "renderCore",
        value: function(options) {
            var offset = 0;
            var $menu = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENTS_CLASS).appendTo(options.$container);
            if (options.isCompact) {
                $menu.addClass(COMPACT_DROPDOWN_APPOINTMENTS_CLASS);
                offset = this.instance.fire("getCellWidth") - options.buttonWidth - OFFSET
            }
            this._createAppointmentClickAction();
            this._createDropDownMenu({
                $element: $menu,
                items: options.items,
                itemTemplate: options.itemTemplate,
                buttonWidth: options.buttonWidth
            }, options.isCompact);
            when.apply(null, options.items.colors).done(function() {
                this._paintMenuButton($menu, options.buttonColor, arguments)
            }.bind(this));
            this._applyInnerShadow($menu, options.buttonWidth);
            this.setPosition($menu, {
                top: options.coordinates.top,
                left: options.coordinates.left + offset
            });
            return $menu
        }
    }, {
        key: "repaintExisting",
        value: function($container) {
            var appointmentsSelector = ["", DROPDOWN_APPOINTMENTS_CLASS, "dx-dropdownmenu"].join(".");
            $container.find(appointmentsSelector).each(function(count, element) {
                return _drop_down_menu2.default.getInstance(element).repaint()
            })
        }
    }, {
        key: "_paintMenuButton",
        value: function($menu, color, itemsColors) {
            var paintButton = true,
                currentItemColor = void 0;
            color && color.done(function(color) {
                if (itemsColors.length) {
                    currentItemColor = itemsColors[0];
                    for (var i = 1; i < itemsColors.length; i++) {
                        if (currentItemColor !== itemsColors[i]) {
                            paintButton = false;
                            break
                        }
                        currentItemColor = color
                    }
                }
                color && paintButton && $menu.css("backgroundColor", color)
            }.bind(this))
        }
    }, {
        key: "_applyInnerShadow",
        value: function($element) {
            $element.css("boxShadow", "inset " + $element.get(0).getBoundingClientRect().width + "px 0 0 0 rgba(0, 0, 0, 0.3)")
        }
    }, {
        key: "_createAppointmentClickAction",
        value: function() {
            this._appointmentClickAction = this.instance._createActionByOption("onAppointmentClick", {
                afterExecute: function(e) {
                    var config = e.args[0];
                    config.event.stopPropagation();
                    this.instance.fire("showEditAppointmentPopup", {
                        data: config.appointmentData
                    })
                }.bind(this)
            })
        }
    }, {
        key: "_createDropDownMenu",
        value: function(config, isCompact) {
            var $menu = config.$element,
                items = config.items;
            if (!_drop_down_menu2.default.getInstance($menu)) {
                this._initDynamicTemplate(items);
                this._initDynamicButtonTemplate(items.data.length, isCompact);
                var template = this.instance._getAppointmentTemplate("dropDownAppointmentTemplate"),
                    buttonTemplate = this.instance._getAppointmentTemplate("appointmentCollectorTemplate");
                this.instance._createComponent($menu, _drop_down_menu2.default, {
                    buttonIcon: null,
                    usePopover: true,
                    popupHeight: "auto",
                    popupMaxHeight: 200,
                    items: items.data,
                    buttonTemplate: this._createListButtonTemplate(buttonTemplate, items, isCompact),
                    itemTemplate: this._createListItemTemplate(template),
                    buttonWidth: config.buttonWidth,
                    closeOnClick: false,
                    activeStateEnabled: false,
                    focusStateEnabled: this.instance.option("focusStateEnabled"),
                    onItemClick: this._onListItemClick.bind(this),
                    onItemRendered: function(args) {
                        this._onListItemRenderedCore(args, $menu)
                    }.bind(this)
                })
            }
        }
    }, {
        key: "_createListButtonTemplate",
        value: function(template, items, isCompact) {
            return new _function_template2.default(function(options) {
                var model = {
                    appointmentCount: items.data.length,
                    isCompact: isCompact
                };
                return template.render({
                    model: model,
                    container: options.container
                })
            })
        }
    }, {
        key: "_createListItemTemplate",
        value: function(template) {
            return new _function_template2.default(function(options) {
                return template.render({
                    model: options.model,
                    index: options.index,
                    container: options.container
                })
            })
        }
    }, {
        key: "_onListItemClick",
        value: function(args) {
            var mappedData = this.instance.fire("mapAppointmentFields", args),
                result = (0, _extend.extendFromObject)(mappedData, args, false);
            this._appointmentClickAction(this._clearExcessFields(result))
        }
    }, {
        key: "_onListItemRenderedCore",
        value: function(args, $menu) {
            var _this2 = this;
            if (!this.instance._allowDragging()) {
                return
            }
            var $item = args.itemElement,
                itemData = args.itemData,
                settings = itemData.settings;
            _events_engine2.default.on($item, DRAG_START_EVENT_NAME, function() {
                _this2._onAppointmentDragStart($item, itemData, settings, $menu)
            });
            _events_engine2.default.on($item, DRAG_UPDATE_EVENT_NAME, function(e) {
                _drop_down_menu2.default.getInstance($menu).close();
                _this2._onAppointmentDragUpdate(e, itemData.allDay)
            });
            _events_engine2.default.on($item, DRAG_END_EVENT_NAME, function() {
                _this2._onAppointmentDragEnd(itemData)
            })
        }
    }, {
        key: "_onAppointmentDragStart",
        value: function($item, itemData, settings, $menu, e) {
            var appointmentInstance = this.instance.getAppointmentsInstance(),
                appointmentIndex = appointmentInstance.option("items").length;
            settings[0].isCompact = false;
            settings[0].virtual = false;
            var appointmentData = {
                itemData: itemData,
                settings: settings
            };
            appointmentInstance._currentAppointmentSettings = settings;
            appointmentInstance._renderItem(appointmentIndex, appointmentData);
            var $items = appointmentInstance._findItemElementByItem(itemData);
            if ($items.length > 0) {
                this._prepareDragItem($menu, $items, appointmentData.settings)
            }
        }
    }, {
        key: "_onAppointmentDragUpdate",
        value: function(e, allDay) {
            var coordinates = {
                left: this._startPosition.left + e.offset.x,
                top: this._startPosition.top + e.offset.y
            };
            this.instance.getAppointmentsInstance().notifyObserver("correctAppointmentCoordinates", {
                coordinates: coordinates,
                allDay: allDay,
                isFixedContainer: false,
                callback: function(result) {
                    if (result) {
                        coordinates = result
                    }
                }
            });
            _translator2.default.move(this._$draggedItem, coordinates)
        }
    }, {
        key: "_onAppointmentDragEnd",
        value: function(itemData) {
            var appointments = this.instance.getAppointmentsInstance(),
                newCellIndex = this.instance._workSpace.getDroppableCellIndex(),
                oldCellIndex = this.instance._workSpace.getCellIndexByCoordinates(this._startPosition);
            _events_engine2.default.trigger(this._$draggedItem, "dxdragend");
            newCellIndex === oldCellIndex && appointments._clearItem({
                itemData: itemData
            });
            delete this._$draggedItem
        }
    }, {
        key: "_clearExcessFields",
        value: function(data) {
            delete data.itemData;
            delete data.itemIndex;
            delete data.itemElement;
            return data
        }
    }, {
        key: "_prepareDragItem",
        value: function($menu, $items, settings) {
            this._$draggedItem = $items.length > 1 ? this._getRecurrencePart($items, settings[0].startDate) : $items[0];
            var menuPosition = _translator2.default.locate($menu);
            this._startPosition = {
                top: menuPosition.top,
                left: menuPosition.left
            };
            _translator2.default.move(this._$draggedItem, this._startPosition);
            _events_engine2.default.trigger(this._$draggedItem, "dxdragstart")
        }
    }, {
        key: "_getRecurrencePart",
        value: function(appointments, startDate) {
            var result;
            for (var i = 0; i < appointments.length; i++) {
                var $appointment = appointments[i],
                    appointmentStartDate = $appointment.data("dxAppointmentStartDate");
                if (appointmentStartDate.getTime() === startDate.getTime()) {
                    result = $appointment
                }
            }
            return result
        }
    }, {
        key: "_initDynamicTemplate",
        value: function(items) {
            var _this3 = this;
            this.instance._defaultTemplates.dropDownAppointment = new _function_template2.default(function(options) {
                return _this3._createDropDownAppointmentTemplate(options.model, (0, _renderer2.default)(options.container), items.colors[options.index])
            })
        }
    }, {
        key: "_initDynamicButtonTemplate",
        value: function(count, isCompact) {
            var _this4 = this;
            this.instance._defaultTemplates.appointmentCollector = new _function_template2.default(function(options) {
                return _this4._createButtonTemplate(count, (0, _renderer2.default)(options.container), isCompact)
            })
        }
    }, {
        key: "_createButtonTemplate",
        value: function(appointmentCount, element, isCompact) {
            var text = isCompact ? appointmentCount : _message2.default.getFormatter("dxScheduler-moreAppointments")(appointmentCount);
            return element.append([(0, _renderer2.default)("<span>").text(text)]).addClass(DROPDOWN_APPOINTMENTS_CONTENT_CLASS)
        }
    }, {
        key: "_createDropDownAppointmentTemplate",
        value: function(appointmentData, appointmentElement, color) {
            var $title, $date, $infoBlock, dateString = "",
                appointmentMarkup = [],
                borderSide = "left",
                text = this.instance.fire("getField", "text", appointmentData);
            appointmentElement.addClass(DROPDOWN_APPOINTMENT_CLASS);
            if (this.instance.option("rtlEnabled")) {
                borderSide = "right"
            }
            color && color.done(function(color) {
                appointmentElement.css(SIDE_BORDER_COLOR_STYLES[borderSide], color)
            });
            var startDate = this.instance.fire("getField", "startDate", appointmentData),
                endDate = this.instance.fire("getField", "endDate", appointmentData),
                startDateTimeZone = this.instance.fire("getField", "startDateTimeZone", appointmentData),
                endDateTimeZone = this.instance.fire("getField", "endDateTimeZone", appointmentData);
            startDate = this.instance.fire("convertDateByTimezone", startDate, startDateTimeZone);
            endDate = this.instance.fire("convertDateByTimezone", endDate, endDateTimeZone);
            this.instance.fire("formatDates", {
                startDate: startDate,
                endDate: endDate,
                formatType: "DATETIME",
                callback: function(result) {
                    dateString = result
                }
            });
            $infoBlock = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENT_INFO_BLOCK_CLASS);
            $title = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENT_TITLE_CLASS).text(text);
            $date = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENT_DATE_CLASS).text(dateString);
            $infoBlock.append([$title, $date]);
            appointmentMarkup.push($infoBlock);
            appointmentMarkup.push(this._createButtons(appointmentData));
            appointmentElement.append(appointmentMarkup);
            return appointmentElement
        }
    }, {
        key: "_createButtons",
        value: function(appointmentData) {
            var _this5 = this;
            var editing = this.instance.option("editing"),
                allowDeleting = false;
            if (!editing) {
                return ""
            }
            if (true === editing) {
                allowDeleting = true
            }
            if (_type2.default.isObject(editing)) {
                allowDeleting = editing.allowDeleting
            }
            var $container = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENT_BUTTONS_BLOCK_CLASS),
                $removeButton = (0, _renderer2.default)("<div>").addClass(DROPDOWN_APPOINTMENT_REMOVE_BUTTON_CLASS);
            if (allowDeleting) {
                $container.append($removeButton);
                this.instance._createComponent($removeButton, _button2.default, {
                    icon: "trash",
                    height: REMOVE_BUTTON_SIZE,
                    width: REMOVE_BUTTON_SIZE,
                    onClick: function(e) {
                        e.event.stopPropagation();
                        _this5.instance.deleteAppointment(appointmentData)
                    }
                })
            }
            return $container
        }
    }]);
    return CompactAppointmentsDesktopStrategy
}(_compactAppointmentsStrategyBase.CompactAppointmentsStrategyBase);
