/**
 * DevExtreme (ui/scheduler/tooltip_strategies/desktopTooltipStrategy.js)
 * Version: 19.1.0 (build 19085-0305)
 * Build date: Tue Mar 26 2019
 *
 * Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DesktopTooltipStrategy = void 0;
var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) {
                descriptor.writable = true
            }
            Object.defineProperty(target, descriptor.key, descriptor)
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) {
            defineProperties(Constructor.prototype, protoProps)
        }
        if (staticProps) {
            defineProperties(Constructor, staticProps)
        }
        return Constructor
    }
}();
var _renderer = require("../../../core/renderer");
var _renderer2 = _interopRequireDefault(_renderer);
var _tooltip = require("../../tooltip");
var _tooltip2 = _interopRequireDefault(_tooltip);
var _ui = require("../../tooltip/ui.tooltip");
var _ui2 = _interopRequireDefault(_ui);
var _tooltipStrategyBase = require("./tooltipStrategyBase");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _possibleConstructorReturn(self, call) {
    if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return call && ("object" === typeof call || "function" === typeof call) ? call : self
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass)
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass
    }
}
var APPOINTMENT_TOOLTIP_WRAPPER_CLASS = "dx-scheduler-appointment-tooltip-wrapper";
var DesktopTooltipStrategy = exports.DesktopTooltipStrategy = function(_TooltipStrategyBase) {
    _inherits(DesktopTooltipStrategy, _TooltipStrategyBase);

    function DesktopTooltipStrategy() {
        _classCallCheck(this, DesktopTooltipStrategy);
        return _possibleConstructorReturn(this, (DesktopTooltipStrategy.__proto__ || Object.getPrototypeOf(DesktopTooltipStrategy)).apply(this, arguments))
    }
    _createClass(DesktopTooltipStrategy, [{
        key: "show",
        value: function(itemList) {
            var item = itemList[0];
            if (!item || this.tooltip && this.tooltip.option("visible") && (0, _renderer2.default)(this.tooltip.option("target")).get(0) === (0, _renderer2.default)(item.$appointment).get(0)) {
                return
            }
            this.hide();
            this.$tooltip = (0, _renderer2.default)("<div>").appendTo(this.scheduler.$element()).addClass(APPOINTMENT_TOOLTIP_WRAPPER_CLASS);
            this.tooltip = this.scheduler._createComponent(this.$tooltip, _tooltip2.default, {
                visible: true,
                target: item.$appointment,
                rtlEnabled: this.scheduler.option("rtlEnabled"),
                contentTemplate: this._renderTemplate(item.data, item.currentData, item.$appointment),
                position: {
                    my: "bottom",
                    at: "top",
                    of: item.$appointment,
                    boundary: this._isAppointmentInAllDayPanel(item.data) ? this.scheduler.$element() : this.scheduler.getWorkSpaceScrollableContainer(),
                    collision: "fit flipfit",
                    offset: this.scheduler.option("_appointmentTooltipOffset")
                }
            })
        }
    }, {
        key: "hide",
        value: function() {
            if (this.$tooltip) {
                this.$tooltip.remove();
                delete this.$tooltip;
                delete this.tooltip;
                _ui2.default.hide()
            }
        }
    }]);
    return DesktopTooltipStrategy
}(_tooltipStrategyBase.TooltipStrategyBase);
